package dev.pfaff.altargui.internal.render;

import dev.pfaff.altargui.internal.Config;
import dev.pfaff.glass.opengl.enums.GLBufferTarget;

import static dev.pfaff.altargui.GuiGlobals.GL;

public sealed interface GLBufferBind extends AutoCloseable {
	@Override
	void close();

	public static GLBufferBind bindBuffer(GLBufferTarget target, int buffer) {
		GL.glBindBuffer(GLBufferTarget.PIXEL_UNPACK_BUFFER, buffer);
		return Config.GL_ALWAYS_UNBIND ? new Unbind(target) : NoUnbind.INSTANCE;
	}

	static final class NoUnbind implements GLBufferBind {
		private static final NoUnbind INSTANCE = new NoUnbind();

		@Override
		public void close() {}
	}

	record Unbind(GLBufferTarget target) implements GLBufferBind {
		@Override
		public void close() {
			GL.glBindBuffer(target, 0);
		}
	}
}
