package dev.pfaff.altargui.shader;

import dev.pfaff.glass.opengl.enums.GLVertexAttribIType;
import dev.pfaff.glass.opengl.enums.GLVertexAttribPointerType;

import java.nio.ByteOrder;

import static java.lang.foreign.ValueLayout.JAVA_INT;

public class Attributes {
	public static final VertexComponentSpec.Attrib ATTRIB_POSITION = new VertexComponentSpec.Attrib("Position",
			GLVertexAttribPointerType.FLOAT,
			2);
	public static final VertexComponentSpec.Attrib ATTRIB_SIZE_1 = new VertexComponentSpec.Attrib("Size",
			GLVertexAttribPointerType.FLOAT,
			1);
	public static final VertexComponentSpec.Attrib ATTRIB_SIZE_2 = new VertexComponentSpec.Attrib("Size",
			GLVertexAttribPointerType.FLOAT,
			2);
	public static final VertexComponentSpec.Attrib ATTRIB_COLOR = new VertexComponentSpec.Attrib("Color",
			GLVertexAttribPointerType.UNSIGNED_BYTE,
			4).withNormalized().withCustomLayout(JAVA_INT.withOrder(ByteOrder.BIG_ENDIAN));
	public static final VertexComponentSpec.Attrib ATTRIB_UV_MIN = new VertexComponentSpec.Attrib("UVMin",
			GLVertexAttribIType.UNSIGNED_SHORT,
			2);
	public static final VertexComponentSpec.Attrib ATTRIB_UV_MAX_MINUS_ONE = new VertexComponentSpec.Attrib("UVMaxMinusOne",
			GLVertexAttribIType.UNSIGNED_SHORT,
			2);
	public static final VertexComponentSpec.Attrib ATTRIB_CHAR = new VertexComponentSpec.Attrib("Char",
			GLVertexAttribIType.UNSIGNED_BYTE,
			1);
	public static final VertexComponentSpec.Attrib ATTRIB_FLAGS = new VertexComponentSpec.Attrib("Flags",
			GLVertexAttribIType.UNSIGNED_BYTE,
			1);
	public static final VertexComponentSpec.Attrib ATTRIB_UV_BASE = new VertexComponentSpec.Attrib("UVBase",
			// The atlas is divided into 256 units and the font atlas will be unit-aligned, allowing the base to be
			// represented by a pair of bytes (x, y).
			GLVertexAttribIType.UNSIGNED_BYTE,
			2);
	public static final VertexComponentSpec.Attrib ATTRIB_UV_EXTENT_2_BYTE = new VertexComponentSpec.Attrib("UVExtent",
			GLVertexAttribIType.UNSIGNED_BYTE,
			2);
}
